# -- (c) Copyright 2013 Xilinx, Inc. All rights reserved.
# --
# -- This file contains confidential and proprietary information
# -- of Xilinx, Inc. and is protected under U.S. and 
# -- international copyright and other intellectual property
# -- laws.
# --
# -- DISCLAIMER
# -- This disclaimer is not a license and does not grant any
# -- rights to the materials distributed herewith. Except as
# -- otherwise provided in a valid license issued to you by
# -- Xilinx, and to the maximum extent permitted by applicable
# -- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
# -- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
# -- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
# -- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
# -- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
# -- (2) Xilinx shall not be liable (whether in contract or tort,
# -- including negligence, or under any other theory of
# -- liability) for any loss or damage of any kind or nature
# -- related to, arising under or in connection with these
# -- materials, including for any direct, or any indirect,
# -- special, incidental, or consequential loss or damage
# -- (including loss of data, profits, goodwill, or any type of
# -- loss or damage suffered as a result of any action brought
# -- by a third party) even if such damage or loss was
# -- reasonably foreseeable or Xilinx had been advised of the
# -- possibility of the same.
# --
# -- CRITICAL APPLICATIONS
# -- Xilinx products are not designed or intended to be fail-
# -- safe, or for use in any application requiring fail-safe
# -- performance, such as life-support or safety devices or
# -- systems, Class III medical devices, nuclear facilities,
# -- applications related to the deployment of airbags, or any
# -- other applications that could lead to death, personal
# -- injury, or severe property or environmental damage
# -- (individually and collectively, "Critical
# -- Applications"). Customer assumes the sole risk and
# -- liability of any use of Xilinx products in Critical
# -- Applications, subject only to applicable laws and
# -- regulations governing limitations on product liability.
# --
# -- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
# -- PART OF THIS FILE AT ALL TIMES.
#
# This file will recreate XAPP1168
# To use:
# -Open Vivado
# -In the Vivado TCL Console, change directory to the extracted location of this file.
# For example: 'cd C:/designs/xapp1168'
# -In the Vivado TCL Console, type 'source source.tcl'

file mkdir ip_repo

create_project package_axi_lite_slave package_axi_lite_slave -part xc7vx485tffg1157-1 -force
add_files -norecurse hdl/verilog/axi_lite_slave.v
import_files -force -norecurse
update_compile_order -fileset sources_1
update_compile_order -fileset sim_1
ipx::package_project 
set_property library {user} [ipx::current_core]
set_property vendor_display_name {YourCompanyName} [ipx::current_core]
set_property company_url {www.YourCompanyName.com} [ipx::current_core]
set_property company_url {http://www.YourCompanyName.com} [ipx::current_core]
set_property vendor {YourCompanyName.com} [ipx::current_core]
set_property supported_families {{kintex7} {Pre-Production} {virtex7} {Production}} [ipx::current_core]
set_property taxonomy {{/Embedded_Processing/AXI_Infrastructure}} [ipx::current_core]
ipx::check_integrity [ipx::current_core]
ipx::archive_core {ip_repo/YourCompanyName.com_user_axi_lite_slave_1.0.zip} [ipx::current_core]
close_project

create_project package_axi_lite_master package_axi_lite_master -part xc7vx485tffg1157-1 -force
add_files -norecurse hdl/verilog/axi_lite_master.v
import_files -force -norecurse
update_compile_order -fileset sources_1
update_compile_order -fileset sim_1
ipx::package_project 
set_property library {user} [ipx::current_core]
set_property vendor_display_name {YourCompanyName} [ipx::current_core]
set_property company_url {www.YourCompanyName.com} [ipx::current_core]
set_property company_url {http://www.YourCompanyName.com} [ipx::current_core]
set_property vendor {YourCompanyName.com} [ipx::current_core]
set_property taxonomy {{/Embedded_Processing/AXI_Infrastructure}} [ipx::current_core]
set_property supported_families {{virtex7} {Production}} [ipx::current_core]
set_property supported_families {{virtex7} {Production}} [ipx::current_core]
set_property supported_families {{kintex7} {Pre-Production} {virtex7} {Production}} [ipx::current_core]
set_property description {Number of Transactions} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
set_property display_name {Number of Transactions} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
set_property value_validation_range_maximum {64} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
set_property value_validation_range_minimum {1} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
ipx::check_integrity [ipx::current_core]
ipx::archive_core {ip_repo/YourCompanyName.com_user_axi_lite_master_1.0.zip} [ipx::current_core]
close_project

create_project package_axi_slave package_axi_slave -part xc7vx485tffg1157-1 -force
add_files -norecurse hdl/verilog/axi_slave.v
import_files -force -norecurse
update_compile_order -fileset sources_1
update_compile_order -fileset sim_1
ipx::package_project 
set_property library {user} [ipx::current_core]
set_property vendor {YourCompanyName.com} [ipx::current_core]
set_property vendor_display_name {Your Company Name} [ipx::current_core]
set_property company_url {www.YourCompanyName.com} [ipx::current_core]
set_property company_url {http://www.YourCompanyName.com} [ipx::current_core]
set_property taxonomy {{/Embedded_Processing/AXI_Infrastructure}} [ipx::current_core]
set_property supported_families {{kintex7} {Pre-Production} {virtex7} {Production}} [ipx::current_core]
set_property display_name {Data Width} [ipx::get_hdl_parameter C_S_AXI_DATA_WIDTH [ipx::current_core]]
set_property display_name {Data Width} [ipx::get_user_parameter C_S_AXI_DATA_WIDTH [ipx::current_core]]
set_property value_validation_type {list} [ipx::get_user_parameter C_S_AXI_DATA_WIDTH [ipx::current_core]]
set_property value_validation_list {{32} {64}} [ipx::get_user_parameter C_S_AXI_DATA_WIDTH [ipx::current_core]]
set_property value {32} [ipx::get_hdl_parameter C_S_AXI_DATA_WIDTH [ipx::current_core]]
set_property value {32} [ipx::get_user_parameter C_S_AXI_DATA_WIDTH [ipx::current_core]]
set_property display_name {ID Width} [ipx::get_user_parameter C_S_AXI_ID_WIDTH [ipx::current_core]]
set_property description {ID Width} [ipx::get_user_parameter C_S_AXI_ID_WIDTH [ipx::current_core]]
set_property value_validation_range_maximum {32} [ipx::get_user_parameter C_S_AXI_ID_WIDTH [ipx::current_core]]
set_property value_validation_range_minimum {1} [ipx::get_user_parameter C_S_AXI_ID_WIDTH [ipx::current_core]]
ipx::check_integrity [ipx::current_core]
ipx::archive_core {ip_repo/YourCompanyName.com_user_axi_slave_1.0.zip} [ipx::current_core]
close_project

create_project package_axi_master package_axi_master -part xc7vx485tffg1157-1 -force
add_files -norecurse hdl/verilog/axi_master.v
import_files -force -norecurse
update_compile_order -fileset sources_1
update_compile_order -fileset sim_1
ipx::package_project 
set_property library {user} [ipx::current_core]
set_property vendor {YourCompanyName.com} [ipx::current_core]
set_property vendor_display_name {Your Company Name} [ipx::current_core]
set_property company_url {www.YourCompanyName.com} [ipx::current_core]
set_property taxonomy {{/Embedded_Processing/AXI_Infrastructure}} [ipx::current_core]
set_property supported_families {{kintex7} {Pre-Production} {virtex7} {Production}} [ipx::current_core]
set_property supported_families {{kintex7} {Pre-Production} {virtex7} {Production}} [ipx::current_core]
set_property display_name {Data Width} [ipx::get_hdl_parameter C_M_AXI_DATA_WIDTH [ipx::current_core]]
set_property display_name {Data Width} [ipx::get_user_parameter C_M_AXI_DATA_WIDTH [ipx::current_core]]
set_property value_validation_type {list} [ipx::get_user_parameter C_M_AXI_DATA_WIDTH [ipx::current_core]]
set_property value_validation_list {{32} {64}} [ipx::get_user_parameter C_M_AXI_DATA_WIDTH [ipx::current_core]]
set_property value {32} [ipx::get_hdl_parameter C_M_AXI_DATA_WIDTH [ipx::current_core]]
set_property value {32} [ipx::get_user_parameter C_M_AXI_DATA_WIDTH [ipx::current_core]]
set_property description {Burst Length} [ipx::get_user_parameter C_BURST_LEN [ipx::current_core]]
set_property display_name {Burst Length} [ipx::get_user_parameter C_BURST_LEN [ipx::current_core]]
set_property value_validation_range_minimum {1} [ipx::get_user_parameter C_BURST_LEN [ipx::current_core]]
set_property value_validation_range_maximum {256} [ipx::get_user_parameter C_BURST_LEN [ipx::current_core]]
set_property description {Number of Transactions} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
set_property display_name {Number of Transactions} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
set_property value_validation_range_maximum {64} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
set_property value_validation_range_minimum {1} [ipx::get_user_parameter C_TRANSACTIONS_NUM [ipx::current_core]]
ipx::check_integrity [ipx::current_core]
ipx::archive_core {ip_repo/YourCompanyName.com_user_axi_master_1.0.zip} [ipx::current_core]
close_project

create_project package_axi_stream_master package_axi_stream_master -part xc7vx485tffg1157-1 -force
add_files -norecurse hdl/verilog/axi_stream_master.v
import_files -force -norecurse
update_compile_order -fileset sources_1
update_compile_order -fileset sim_1
ipx::package_project 
set_property library {user} [ipx::current_core]
set_property vendor {YourCompanyName.com} [ipx::current_core]
set_property vendor_display_name {Your Company Name} [ipx::current_core]
set_property company_url {www.YourCompanyName.com} [ipx::current_core]
set_property taxonomy {{/AXI_Infrastructure}} [ipx::current_core]
set_property description {Packet Length} [ipx::get_user_parameter C_PACKET_LENGTH [ipx::current_core]]
set_property display_name {Packet Length} [ipx::get_user_parameter C_PACKET_LENGTH [ipx::current_core]]
set_property value_validation_range_maximum {64} [ipx::get_user_parameter C_PACKET_LENGTH [ipx::current_core]]
set_property value_validation_range_minimum {1} [ipx::get_user_parameter C_PACKET_LENGTH [ipx::current_core]]
set_property display_name {Data Width} [ipx::get_user_parameter C_M_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
set_property description {Data Width in bytes} [ipx::get_user_parameter C_M_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
set_property display_name {Data Width in bytes} [ipx::get_user_parameter C_M_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
set_property value_validation_range_maximum {512} [ipx::get_user_parameter C_M_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
set_property value_validation_range_minimum {1} [ipx::get_user_parameter C_M_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
ipx::check_integrity [ipx::current_core]
ipx::archive_core {ip_repo/YourCompanyName.com_user_axi_stream_master_1.0.zip} [ipx::current_core]
close_project

create_project package_axi_stream_slave package_axi_stream_slave -part xc7vx485tffg1157-1 -force
add_files -norecurse hdl/verilog/axi_stream_slave.v
import_files -force -norecurse
update_compile_order -fileset sources_1
update_compile_order -fileset sim_1
ipx::package_project 
set_property library {user} [ipx::current_core]
set_property vendor {YourCompanyName.com} [ipx::current_core]
set_property vendor_display_name {Your Company Name} [ipx::current_core]
set_property company_url {www.YourCompanyName.com} [ipx::current_core]
set_property taxonomy {{/AXI_Infrastructure}} [ipx::current_core]
set_property supported_families {{kintex7} {Pre-Production} {virtex7} {Production}} [ipx::current_core]
set_property description {Data Width in bytes} [ipx::get_user_parameter C_S_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
set_property display_name {Data Width in bytes} [ipx::get_user_parameter C_S_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
set_property value_validation_range_maximum {512} [ipx::get_user_parameter C_S_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
set_property value_validation_range_minimum {1} [ipx::get_user_parameter C_S_AXIS_TDATA_NUM_BYTES [ipx::current_core]]
ipx::check_integrity [ipx::current_core]
ipx::archive_core {ip_repo/YourCompanyName.com_user_axi_stream_slave_1.0.zip} [ipx::current_core]
close_project

#Create System Projects
create_project ipi_lite_project ipi_lite_project -part xc7vx485tffg1157-1 -force
add_files -fileset sim_1 -norecurse tb/verilog/lite_system_wrapper_tb.v
import_files -force -norecurse
update_compile_order -fileset sim_1
set_property ip_repo_paths  ip_repo [current_fileset]
update_ip_catalog
update_ip_catalog -add_ip ip_repo/YourCompanyName.com_user_axi_master_1.0.zip -repo_path ip_repo
update_ip_catalog -add_ip ip_repo/YourCompanyName.com_user_axi_lite_slave_1.0.zip -repo_path ip_repo
update_ip_catalog -add_ip ip_repo/YourCompanyName.com_user_axi_slave_1.0.zip -repo_path ip_repo
update_ip_catalog -add_ip ip_repo/YourCompanyName.com_user_axi_lite_master_1.0.zip -repo_path ip_repo
update_ip_catalog -add_ip ip_repo/YourCompanyName.com_user_axi_stream_master_1.0.zip -repo_path ip_repo
update_ip_catalog -add_ip ip_repo/YourCompanyName.com_user_axi_stream_slave_1.0.zip -repo_path ip_repo
create_bd_design "lite_system"
startgroup
create_bd_cell -type ip -vlnv YourCompanyName.com:user:axi_lite_slave:1.0 axi_lite_slave_1
endgroup
startgroup
create_bd_cell -type ip -vlnv YourCompanyName.com:user:axi_lite_master:1.0 axi_lite_master_1
endgroup
startgroup
create_bd_port -dir I -type clk ACLK
set_property CONFIG.FREQ_HZ 100000000 [ get_bd_ports /ACLK]
endgroup
create_bd_port -dir I -type rst ARESETN
connect_bd_net [get_bd_ports /ACLK] [get_bd_pins /axi_lite_master_1/M_AXI_ACLK]
connect_bd_net -net [get_bd_net /aclk_1] [get_bd_ports /ACLK] [get_bd_pins /axi_lite_slave_1/S_AXI_ACLK]
connect_bd_net [get_bd_ports /ARESETN] [get_bd_pins /axi_lite_master_1/M_AXI_ARESETN]
connect_bd_net -net [get_bd_net /aresetn_1] [get_bd_ports /ARESETN] [get_bd_pins /axi_lite_slave_1/S_AXI_ARESETN]
connect_bd_intf_net [get_bd_intf_pins /axi_lite_master_1/M_AXI] [get_bd_intf_pins /axi_lite_slave_1/S_AXI]
regenerate_bd_layout
assign_bd_address
validate_bd_design
save_bd_design
make_wrapper -files [get_files ipi_lite_project/ipi_lite_project.srcs/sources_1/bd/lite_system/lite_system.bd] -top
import_files -force -norecurse ipi_lite_project/ipi_lite_project.srcs/sources_1/bd/lite_system/hdl/lite_system_wrapper.v
update_compile_order -fileset sources_1
set_property runtime {} [get_filesets sim_1]
launch_xsim -simset sim_1 -mode behavioral
add_wave {{/lite_system_wrapper_tb/lite_system_wrapper_i/lite_system_i}} 
run all
close_sim -force
close_project

create_project ipi_axi_project ipi_axi_project -part xc7vx485tffg1157-1 -force
add_files -fileset sim_1 -norecurse tb/verilog/axi_system_wrapper_tb.v
import_files -force -norecurse
update_compile_order -fileset sim_1
set_property ip_repo_paths  ip_repo [current_fileset]
update_ip_catalog
create_bd_design "axi_system"
startgroup
create_bd_cell -type ip -vlnv YourCompanyName.com:user:axi_master:1.0 axi_master_1
endgroup
startgroup
create_bd_cell -type ip -vlnv YourCompanyName.com:user:axi_slave:1.0 axi_slave_1
endgroup
startgroup
create_bd_port -dir I -type clk ACLK
set_property CONFIG.FREQ_HZ 100000000 [ get_bd_ports /ACLK]
endgroup
create_bd_port -dir I -type rst ARESETN
connect_bd_net [get_bd_ports /ACLK] [get_bd_pins /axi_slave_1/S_AXI_ACLK]
connect_bd_net -net [get_bd_net /aclk_1] [get_bd_ports /ACLK] [get_bd_pins /axi_master_1/M_AXI_ACLK]
connect_bd_net [get_bd_ports /ARESETN] [get_bd_pins /axi_slave_1/S_AXI_ARESETN]
connect_bd_net -net [get_bd_net /aresetn_1] [get_bd_ports /ARESETN] [get_bd_pins /axi_master_1/M_AXI_ARESETN]
connect_bd_intf_net [get_bd_intf_pins /axi_master_1/M_AXI] [get_bd_intf_pins /axi_slave_1/S_AXI]
regenerate_bd_layout
assign_bd_address
validate_bd_design
save_bd_design
make_wrapper -files [get_files ipi_axi_project/ipi_axi_project.srcs/sources_1/bd/axi_system/axi_system.bd] -top
import_files -force -norecurse ipi_axi_project/ipi_axi_project.srcs/sources_1/bd/axi_system/hdl/axi_system_wrapper.v
update_compile_order -fileset sources_1
set_property runtime {} [get_filesets sim_1]
launch_xsim -simset sim_1 -mode behavioral
add_wave {{/axi_system_wrapper_tb/axi_system_wrapper_i/axi_system_i}} 
run all
close_sim -force
close_project

create_project ipi_stream_project ipi_stream_project -part xc7vx485tffg1157-1 -force
add_files -fileset sim_1 -norecurse tb/verilog/axi_stream_system_wrapper_tb.v
import_files -force -norecurse
update_compile_order -fileset sim_1
set_property ip_repo_paths  ip_repo [current_fileset]
update_ip_catalog
create_bd_design "axi_stream_system"
startgroup
create_bd_cell -type ip -vlnv YourCompanyName.com:user:axi_stream_master:1.0 axi_stream_master_1
endgroup
startgroup
create_bd_cell -type ip -vlnv YourCompanyName.com:user:axi_stream_slave:1.0 axi_stream_slave_1
endgroup
startgroup
create_bd_port -dir I -type clk ACLK
set_property CONFIG.FREQ_HZ 100000000 [ get_bd_ports /ACLK]
endgroup
create_bd_port -dir I -type rst ARESETN
connect_bd_net [get_bd_ports /ACLK] [get_bd_pins /axi_stream_slave_1/AXIS_ACLK]
connect_bd_net -net [get_bd_net /aclk_1] [get_bd_ports /ACLK] [get_bd_pins /axi_stream_master_1/AXIS_ACLK]
connect_bd_net [get_bd_ports /ARESETN] [get_bd_pins /axi_stream_master_1/AXIS_ARESETN]
connect_bd_net -net [get_bd_net /aresetn_1] [get_bd_ports /ARESETN] [get_bd_pins /axi_stream_slave_1/AXIS_ARESETN]
connect_bd_intf_net [get_bd_intf_pins /axi_stream_slave_1/S_AXIS] [get_bd_intf_pins /axi_stream_master_1/M_AXIS]
regenerate_bd_layout
save_bd_design
make_wrapper -files [get_files ipi_stream_project/ipi_stream_project.srcs/sources_1/bd/axi_stream_system/axi_stream_system.bd] -top
import_files -force -norecurse ipi_stream_project/ipi_stream_project.srcs/sources_1/bd/axi_stream_system/hdl/axi_stream_system_wrapper.v
update_compile_order -fileset sources_1
set_property runtime {} [get_filesets sim_1]
launch_xsim -simset sim_1 -mode behavioral
add_wave {{/axi_stream_system_wrapper_tb/axi_stream_system_wrapper_i/axi_stream_system_i}} 
run all


